#include "host.h"
#include "arcmode.h"
#include "arcmon.h"

extern UINT8 center_x;
extern UINT8 center_y;

//array of register values to set arcade mode
UINT8 vgaregs13h[]=
{
   0xe7,0x69,0x4f,0x4f,0x91,0x55,0x1f,0x09,0x11,0x00,0x40,0xf2,0xa4,0xef,0x28,0x00,0xf0,0xf2,
   0xe3,0x09,0x06,0x40,0x05,0x41,0x00
};

void arcade_monitor_mode(void)
{
//center it
	centermode();
//then set it
	setmagicmode();
}

void centermode(void)
{
	int hrt, vrt_start, temp, vert_total, vert_display, center, hrt_start;
	int vblnk_start,vrt,vblnk,actx,acty;
	int hblnk = 3;
//get +/- versions of the center vars
	actx =(int)center_x-8;
	acty =(int)center_y-4;

//horizontal retrace width
	hrt = 11;
/* our center 'tweak' variable */
	center = actx;
/* set the hz retrace */
	hrt_start = vgaregs13h[H_RETRACE_START_INDEX];
	hrt_start += center;
/* make sure it's legal */
	if (hrt_start <= vgaregs13h[H_DISPLAY_INDEX])
		hrt_start = vgaregs13h[H_DISPLAY_INDEX] + 1;

	vgaregs13h[H_RETRACE_START_INDEX] = hrt_start;
	temp = hrt_start + hrt;
	vgaregs13h[H_RETRACE_END_INDEX] = temp&0x1f;

 /* set the hz blanking */
	temp = vgaregs13h[H_DISPLAY_INDEX];
   	vgaregs13h[H_BLANKING_START_INDEX] = temp;
   	temp += hblnk;
   	vgaregs13h[H_BLANKING_END_INDEX] = (temp&0x1f) | 0x80;


/* get the vt retrace */
	vrt_start = vgaregs13h[V_RETRACE_START_INDEX] | ((vgaregs13h[OVERFLOW_INDEX] & 0x04) << 6) |
				((vgaregs13h[OVERFLOW_INDEX] & 0x80) << 2);

/* get the width of it */
	temp = vrt_start & ~0x0f;
	temp |=	(vgaregs13h[V_RETRACE_END_INDEX] & 0x0f);

	vrt = temp - vrt_start;


/* set the new retrace start */
	vrt_start += acty;
/* check it's legal, get the display line count */
	vert_display = (vgaregs13h[V_END_INDEX] | ((vgaregs13h[OVERFLOW_INDEX] & 0x02) << 7) |
				((vgaregs13h[OVERFLOW_INDEX] & 0x40) << 3)) + 1;

 	if (vrt_start < vert_display)
		vrt_start = vert_display;

/* and get the vertical line count */
	vert_total = vgaregs13h[V_TOTAL_INDEX] | ((vgaregs13h[OVERFLOW_INDEX] & 0x01) << 8) |
				((vgaregs13h[OVERFLOW_INDEX] & 0x20) << 4);



	vgaregs13h[V_RETRACE_START_INDEX] = (vrt_start & 0xff);
	vgaregs13h[OVERFLOW_INDEX] &= ~0x84;
	vgaregs13h[OVERFLOW_INDEX] |= ((vrt_start & 0x100) >> 6);
	vgaregs13h[OVERFLOW_INDEX] |= ((vrt_start & 0x200) >> 2);
	temp = vrt_start + vrt;


	if (temp > vert_total)
		temp = vert_total;


	vgaregs13h[V_RETRACE_END_INDEX] &= ~0x0f;
	vgaregs13h[V_RETRACE_END_INDEX] |= (temp & 0x0f);

/* get the start of vt blanking */
	vblnk_start = vgaregs13h[V_BLANKING_START_INDEX] | ((vgaregs13h[OVERFLOW_INDEX] & 0x08) << 5) |
					((vgaregs13h[MAXIMUM_SCANLINE_INDEX] & 0x20) << 4);

/* and the end */
	temp = vblnk_start & ~0xff;
	temp |= vgaregs13h[V_BLANKING_END_INDEX];

/* get the width */
	vblnk = temp - vblnk_start;
/* get the new value */
	vblnk_start += acty;
/* check it's legal */
	if (vblnk_start < vert_display)
		vblnk_start = vert_display;
	if (vblnk_start > vert_total)
		vblnk_start = vert_total;

/* set vblank start */
	vgaregs13h[V_BLANKING_START_INDEX] = (vblnk_start & 0xff);
	vgaregs13h[OVERFLOW_INDEX] &= ~0x08;
	vgaregs13h[OVERFLOW_INDEX] |= ((vblnk_start & 0x100) >> 5);
	vgaregs13h[MAXIMUM_SCANLINE_INDEX] &= ~0x20;
	vgaregs13h[MAXIMUM_SCANLINE_INDEX] |= ((vblnk_start &0x200) >> 4);
/* set the vblank end */
	temp = vblnk_start + vblnk;
/* check it's legal */
	if (temp > vert_total)
		temp = vert_total;
	vgaregs13h[V_BLANKING_END_INDEX] = (temp & 0xff);
}
